Subject: RE: Auto-discovery for VPLS in BGP

From: "Hector Avalos" <[email-masked]>
Date: Wed, 30 Apr 2003 00:46:02 +0200

Vach,

Sorry for the delay in answering your questions....

See below,

Cheers,

Hector 

> -----Original Message-----
> From: Vach Kompella [mailto:[email-masked]] 
> Sent: mardi 29 avril 2003 19:21
> To: Yakov Rekhter; [email-masked]
> Cc: Mourad BERKANE; [email-masked]; 
> [email-masked]; [email-masked]
> Subject: Auto-discovery for VPLS in BGP
> 
> 
> Yakov,
> 
> I asked Hector but he didn't answer this.  There is some 
> magic here in the auto-discovery.  How does a PE know its 
> site ID?  Does it auto-discover it?  Is it configured?  If it 
> is configured, how can you guarantee the uniqueness?  With or 
> without reference to all the other PEs in the VPLS?  If with 
> reference to them, then what's the point of auto-discovery?
> 

Within a VPLS domain, each VPLS instance has a VE ID...which is manually
configured or automatically assigned by a provisioning system.
So on a PE participating on  a given VPLS domain, there will be one
single VE ID, regardless of how may local connections  (sites) are
attached to it. 
This VE ID is unique within the VPLS domain only.
A given PE can have several identical VE IDs.....which by definition
should belong to different VPLS domains

> Are site IDs reused?  Can one PE be site ID 1 in one VPN and 
> site ID n (!= 1) in another?
> 

Yes the VE-IDs are reused. Yes a PE can host the VE-ID 1 of VPLS domain
X, and VE-ID 2 of VPLS domain y, and VE-ID 1 for VPLS 
domain z. 
VE-ID are unique ONLY within their VPLS domain. There is no relationship
between the VE-ID numbering and the PE as you think.

> If I understand correctly, the real identifier for a PE in an 
> L2VPN is: VPNID.PE.siteId.  Without that, it won't work.  
> (And I'm not talking of the remote PE's site ID which is in 
> the NLRI, I'm talking of the local PE's site ID).
> 
The NLRI is here after...and it does not include anything about remote
site IDs.......as you mention.
It only includes the VE-ID which is doing the NLRI advertisement.

The extended community Route Target associated with this NLRI defines
the VPLS domain. 

The real identifier for a PE is its next-hop announced with the BGP
advertisement. Like in  2547bis.

  +------------------------------------+
   |  Length (2 octets)                 |
   +------------------------------------+
   |  Route Distinguisher  (8 octets)   |
   +------------------------------------+
   |  VE ID (2 octets)                  |
   +------------------------------------+
   |  Label-block Offset (2 octets)     |
   +------------------------------------+
   |  Label Base (3 octets)             |
   +------------------------------------+
   |  Variable TLVs (0 to N octets)     |
   |              ...                   |
   +------------------------------------+

> If you remove a site from the VPLS, do you renumber site IDs? 
>  Or waste labels?
>

If a PE has two sites belonging to the same VPLS domain (there is one
single VE-ID), and you remove one of this sites,
VE-ID does not need to change.

If the second site is removed, the the VE-ID is removed. There is no
need to renumber the VE-IDs.

Do we waste labels ?.....one label on each PE participating to this VPLS
domain.
But again...I would like to know how big a VPLS domain will be. I asked
the question and nobody has answered this yet.
I do believe that VPLS domains will not be bigger than 50 VPLS
instances.
So in a VPLS domain of 100 instances, if we remove one VPLS instance, we
only 'waste' one single label per PE.
If you remove 50 site, you 'waste' 50 labels.

....as I said before, I know other VPNs implementations that do waste
huge label blocks and seem to work fine from this perspective,
at least nobody complains...

So I believe that this is not really an issue....

> If you remove a range of sites from the NLRI, do you 
> advertise dummy label ranges to avoid renumbering sites?
> 

No need to renumber....you still send the same base and offset values.

> The auto-discovery for 2547 is pretty straightforward because 
> all you need to know is the VPN ID and the PE, which comes 
> from the NLRI.  That comes because the label is "advertised" 
> not "signaled" with the distinction being that the former is 
> useable across the PEs in question and the latter is per-PE.  

As I described before...your statement is not true.

> You can just use loopback address based RDs to ensure route 
> uniqueness, and the only common piece of info that you need 
> for correlation is the VPN ID.

> -Vach